package com.ipaynow.utils;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

import javax.servlet.http.HttpServletRequest;

public class NowPayUtils {

	/**
	 * @param orderDataMap
	 * @param appId
	 * @param appKey
	 * @return
	 */
	public static boolean buildPayData(PayRequest payRequest, String appKey) {
		Map<String, String> dataMap = new HashMap<String, String>();
		dataMap.put("appId", payRequest.getAppId());
		dataMap.put("mhtOrderNo", payRequest.getMhtOrderNo());
		dataMap.put("mhtOrderName", payRequest.getMhtOrderName());
		dataMap.put("mhtCurrencyType", payRequest.getMhtCurrencyType());
		dataMap.put("mhtOrderAmt", payRequest.getMhtOrderAmt());
		dataMap.put("mhtOrderDetail", payRequest.getMhtOrderDetail());
		dataMap.put("mhtOrderType", payRequest.getMhtOrderType());
		dataMap.put("mhtOrderStartTime", payRequest.getMhtOrderStartTime());
		dataMap.put("notifyUrl", payRequest.getNotifyUrl());
		dataMap.put("frontNotifyUrl", payRequest.getFrontNotifyUrl());
		dataMap.put("mhtCharset", payRequest.getMhtCharset());
		dataMap.put("payChannelType", payRequest.getPayChannelType());
		// 商户保留域， 可以不用填。 如果商户有需要对每笔交易记录一些自己的东西，可以放在这个里面
		dataMap.put("mhtReserved", payRequest.getMhtReserved());
		dataMap.put("consumerId", payRequest.getConsumerId());
		dataMap.put("consumerName", payRequest.getConsumerName());

		String mhtSignature = MD5Facade.getFormDataParamMD5(dataMap, appKey,
				"UTF-8");
		payRequest.setMhtSignType("MD5");
		payRequest.setMhtSignature(mhtSignature);
		return true;

	}

	

	public static BackEndRequest buildBackEndRequest(HttpServletRequest request)
			throws IOException {
		BackEndRequest backEndRequest = new BackEndRequest();
		// 获取通知数据需要从body中流式读取
		BufferedReader reader = request.getReader();
		StringBuilder reportBuilder = new StringBuilder();
		String tempStr = "";
		while ((tempStr = reader.readLine()) != null) {
			reportBuilder.append(tempStr);
		}
		String reportContent = reportBuilder.toString();
		Map<String, String> dataMap = FormDateReportConvertor
				.parseFormDataPatternReportWithDecode(reportContent, "UTF-8",
						"UTF-8");

		backEndRequest.setFuncode(dataMap.get("funcode"));
		backEndRequest.setAppId(dataMap.get("appId"));
		backEndRequest.setMhtOrderNo(dataMap.get("mhtOrderNo"));
		backEndRequest.setMhtOrderName(dataMap.get("mhtOrderName"));
		backEndRequest.setMhtOrderType(dataMap.get("mhtOrderType"));
		backEndRequest.setMhtCurrencyType(dataMap.get("mhtCurrencyType"));
		backEndRequest.setMhtOrderAmt(dataMap.get("mhtOrderAmt"));
		backEndRequest.setMhtOrderTimeOut(dataMap.get("mhtOrderTimeOut"));
		backEndRequest.setMhtOrderStartTime(dataMap.get("mhtOrderStartTime"));
		backEndRequest.setMhtCharset(dataMap.get("mhtCharset"));
		backEndRequest.setDeviceType(dataMap.get("deviceType"));
		backEndRequest.setPayChannelType(dataMap.get("payChannelType"));
		backEndRequest.setNowPayAccNo(dataMap.get("nowPayAccNo"));
		backEndRequest.setTradeStatus(dataMap.get("tradeStatus"));
		backEndRequest.setMhtReserved(dataMap.get("mhtReserved"));
		backEndRequest.setSignType(dataMap.get("signType"));
		backEndRequest.setSignature(dataMap.get("signature"));

		return backEndRequest;
	}
	
	public static boolean verifySignature(HttpServletRequest request,String appkey) throws IOException{
		//获取通知数据需要从body中流式读取
				BufferedReader reader = request.getReader();
				StringBuilder reportBuilder = new StringBuilder();
				String tempStr = "";
				while((tempStr = reader.readLine()) != null){
					reportBuilder.append(tempStr);
				}		
				String reportContent = reportBuilder.toString();		
				Map<String,String> dataMap = FormDateReportConvertor.parseFormDataPatternReportWithDecode(reportContent, "UTF-8", "UTF-8");
				
				//去除签名类型和签名值
		        dataMap.remove("signType");
		        String signature = dataMap.remove("signature");

		
		        //验证签名
		        boolean isValidSignature = MD5Facade.validateFormDataParamMD5(dataMap,appkey,signature);

		        return isValidSignature;
	}

}
